const char *message="
Att2Intl v0.1.5
(c) Greg Velichansky (Hmaon / Xylem)
Distributed under the GNU General Public License
Please see http://www.wam.umd.edu/~gvelicha/a2i
";



#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include <process.h>

#define TMPFILENAME "a2itmpfl.asm"

#include "translat.h"

char *extension (char *filename) {
	if (filename == NULL) return NULL;

	while (*filename != '.' && filename != '\0') {
		++filename;
	}

	if (*filename == '.') {
		++filename;
	}

	return filename;
}

void copybasename (char *dest, char *filename) {
	char *extptr;

	extptr = extension (filename);
	while (filename != extptr) {
		*dest = *filename;
		++dest;
		++filename;
	}
	*dest = '\0';
}


void do_externs (FILE *out, FILE *tmp, char *list) {
	char string[80];
	char command[80];
	int n;

	FILE *lst;

	fprintf (out, "; This file was automatically generated using att2intl\n");
	fprintf (out, "; Please see documentation, assuming there is any, if\n");
	fprintf (out, "; att2intl does something wrong\n");
	fprintf (out, "; Greg Velichansky\n");
	fprintf (out, "; (Hmaon / Xylem)\n");
	fprintf (out, "; With support from Cam Horn / Xylem\n\n");
	fprintf (out, "; I MAKE NO WARRANTIES OF ANY KIND REGARDING THIS PRODUCT\n");
	fprintf (out, "; IN FACT I CAN GUARANTEE THAT IN SOME CASES IT WILL *NOT*\n");
	fprintf (out, "; WORK CORRECTLY!\n\n");
	fprintf (out, ".386p\n");
	fprintf (out, "Code32 segment para public use32\n");
	fprintf (out, "assume cs:Code32, ds:Code32\n\n");

	fclose (tmp);

	*command = '\0';
	strcat (command, "tasm /ml ");
	strcat (command, TMPFILENAME);
	strcat (command, " > a2itmpfl.lst");
	printf ("\ndo_externs will run:   %s\n", command);
	fflush (stdout);
	system (command);

	lst = fopen ("a2itmpfl.lst", "rt");

/*	do {
		fscanf (lst, "%s", string);
	} while (!strcmp (string, "Summary")); */

	printf ("scanning summary for externs\n");

	while (!feof (lst)) {
		fscanf (lst, "%s", string);
		if (!strcmp (string, "symbol:")) {
			fscanf (lst, "%s", string);
			fprintf (out, "extrn %s:near\n", string);
		}
	}
	fclose (lst);
	fprintf (out, "\n");

	printf ("Done scanning.\n");

	tmp = fopen (TMPFILENAME, "rt");

	/* skip the first three lines that parse_file puts in */
	for (n = 1; n <= 3; ++n) {
		do {
			*string = fgetc (tmp);
		} while (*string != '\n');
	}

	while ((*string = fgetc (tmp)) != EOF) {
		fputc (*string, out);
	}

	fclose (tmp);
}

int main (int argc, char *argv[]) {
	char *inext;
	char *outname;
	FILE *in, *out, *tmp;

	printf (message);

	if (argc < 2) {
		puts("usage: att2intl <attfile.s>");
		return -1;
	}

	inext = extension (argv[1]);

	if (strcmp (inext, "s") != 0) {
		puts ("input is not .s");
		return -1;
	}

	in = fopen (argv[1], "rt");

	if (in == NULL) {
		printf ("Error on opening %s; ", argv[1]);
		perror ("Error");
	}

	/* 4 is a generous value so ".asm" can always be appended */
	outname = (char *) malloc (strlen (argv[1]) + 4);
	*outname = '\0';
	copybasename (outname, argv[1]);
	strcat (outname, "asm");
	
	out = fopen (outname, "wt");

	tmp = fopen (TMPFILENAME, "wt");

	copybasename (outname, argv[1]);
	strcat (outname, "lst");

	printf ("%s => %s ... \n", argv[1], outname);

	parse_file (in, tmp);
	fflush(tmp);

	do_externs (out, tmp, outname);

	free (outname);

	fclose (out);
	fclose (in);

	printf ("Cleaning up\n");

	system ("del a2itmpfl.asm");
	system ("del a2itmpfl.lst");
	system ("del a2itmpfl.obj");

	printf ("All done!\n");

	return 0;
}

